package com.emamaker.voxeltest.intervaltrees;

import com.emamaker.voxeltest.intervaltrees.utils.Config;
import com.emamaker.voxeltest.intervaltrees.utils.SpaceFillingCurve;
import com.emamaker.voxeltest.intervaltrees.world.WorldManager;
import com.jme3.app.SimpleApplication;
import com.jme3.math.Vector3f;
import com.jme3.renderer.RenderManager;
import com.jme3.util.BufferUtils;

/**
 * This is the Main Class of your Game. It should boot up your game and do
 * initial initialisation Move your Logic into AppStates or Controls or other
 * java classes
 */
public class Voxel extends SimpleApplication {

    WorldManager worldManager = new WorldManager(this);
    public Vector3f oldCamPos = new Vector3f(), pos = new Vector3f();

    public static void main(String[] args) {
        Voxel app = new Voxel();
        app.setShowSettings(true); // Settings dialog not supported on mac
        app.start();

        BufferUtils.setTrackDirectMemoryEnabled(true);
    }

    @Override
    public void simpleInitApp() {
        getFlyByCamera().setMoveSpeed(40f);
        getCamera().setLocation(new Vector3f(Config.RENDER_DISTANCE, Config.RENDER_DISTANCE, Config.RENDER_DISTANCE).mult(Config.CHUNK_SIZE));
        getCamera().lookAt(new Vector3f(Config.CHUNK_SIZE,Config.CHUNK_SIZE, Config.CHUNK_SIZE), Vector3f.UNIT_Y);

        pos.set(this.getCamera().getLocation());
        SpaceFillingCurve.initLUT();
        worldManager.initWorld();
//        worldManager.benchmark();
    }
    public void simpleUpdate(float tpf) {
        pos.set(this.getCamera().getLocation());
        // if (!(pos.equals(oldCamPos))) System.out.println(pos);
        oldCamPos.set(pos);

        worldManager.update();
    }
    
    @Override
    public void simpleRender(RenderManager rm) {
        worldManager.render();
    }
}
