package com.emamaker.voxeltest.intervaltrees.data;

import java.util.ArrayList;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;

public class IntervalMap <V>{
    public TreeMap<Integer, V> treemap = new TreeMap<>();
    int terminator = Integer.MAX_VALUE;
    ArrayList<Integer> toDelete = new ArrayList<>();
    public void insert(int start, int end, V value){
        // if(c.compare(start, end) > 0 || c.compare(start, end) == 0)return;
        if(start >= end) return;

        // take the last key before end
        Map.Entry<Integer,V> end_prev_entry = treemap.lowerEntry(end); //'higherEntry' makes sure that there's no equal case, otherwise the node could be removed as soon as it is inserted

        Map.Entry<Integer, V> end_next_entry = treemap.higherEntry(end);
        Map.Entry<Integer, V> start_entry = treemap.lowerEntry(start);

        // insert the start key. Replaces whatever value is already there. Do not place if the lowerEntry is of the same value
        if(start_entry == null || ( start_entry.getValue() != null && !start_entry.getValue().equals(value))) treemap.put(start, value);

        if(end_next_entry == null){
            if(end_prev_entry != null ) treemap.put(end, end_prev_entry.getKey() > start ? end_prev_entry.getValue():null);
            else treemap.put(end, null);
        }else{
            if(end_next_entry.getValue() != null && end_next_entry.getKey() > end) treemap.put(end, end_prev_entry.getValue());
            else treemap.put(end, end_prev_entry.getValue());
        }
        for(Integer k : treemap.subMap(start, false, end, false).keySet()){
        treemap.remove(k);
        }
    }

    public void insertTerminator(int start){
        treemap.put(start, null);
        terminator=start;
    }

    public Integer begin(){
        return treemap.firstKey();
    }

    public Integer end(){
        return treemap.lastKey();
    }
    Map.Entry<Integer,V> e;
    public V valueAtKey(Integer key){
        return treemap.floorEntry(key).getValue();
    }

    public SortedMap<Integer, V> valuesBetween(Integer start, boolean startInclusive, Integer end, boolean endInclusive){
       return treemap.subMap(start, startInclusive, end, endInclusive);
    }
    public SortedMap<Integer, V> valuesBetween(Integer start , Integer end){
        return treemap.subMap(start, true, end, false);
    }

    V oldValue = null;
    Integer oldK = null;
    public void print() {
        System.out.println("-------");
        for (Integer k : treemap.keySet()) {
               if(oldK != null) System.out.println("[" + oldK + ", " + k + ") --> " + oldValue);
            oldK = k;
            oldValue = treemap.get(k);
        }
        oldK = null;
    }
}
